import ru.ifmo.testlib.Checker;
import ru.ifmo.testlib.InStream;
import ru.ifmo.testlib.Outcome;
import static ru.ifmo.testlib.Outcome.Type.*;

import java.util.HashSet;
import java.util.Arrays;

public class Check implements Checker {
    public Outcome outcome(Outcome.Type type, final String format, final Object... args) {
        return new Outcome(type, String.format(format, args));
    }

    public Outcome test(InStream inf, InStream ouf, InStream ans) {
        String jAns = ans.nextToken().toLowerCase();
        String pAns = ouf.nextToken().toLowerCase();
        if (!jAns.equals(pAns)) {
            return outcome(WA, String.format("Expected %s, found %s", jAns, pAns));
        }
        return outcome(OK, String.valueOf(jAns));
    }
}
