import random
import math
random.seed("personal03/locker")

class TestGen:
    def __init__(self):
        self.test_number = 0
        self.subtask = ""
        self.desc_file = open("../tests.desc", "w")

    def generate_samples(self):             
        self.print_test("abacaba", "sample 1", 0, "preliminary")
        self.print_test("abbcb", "sample 2", 0, "preliminary")
        self.print_test("abab", "sample 3", 0, "preliminary")

    def swap_in_string(self, s, l, r):
        if l > r:
            (l, r) = (r, l)
        return s[:l] + s[r] + s[l + 1:r] + s[l] + s[r + 1:]

    def generate_yes_test(self, maxn, third=False):
        length = maxn
        if random.randint(1, 2) == 1:
            length -= 1
        if (third == True) and (length % 2 == 1):
            length += 1
        s = ""
        for i in range(length // 2):
            s += chr(random.randint(0, 25) + ord('a'))
        if length % 2 == 1:
            s = s + chr(random.randint(0, 25) + ord('a')) + s[::-1]
        else:
            s = s + s[::-1]
        if random.randint(1, 3) == 1:
            self.print_test(s, "Random yes test, palindrome, |s| = %d" % len(s))
        l = random.randint(0, len(s) - 1)
        r = random.randint(l, len(s) - 1)
        while l == r or s[l] == s[r]:
            l = random.randint(0, len(s) - 1)
            r = random.randint(l, len(s) - 1)        
        self.print_test(self.swap_in_string(s, l, r), "Random yes test, |s| = %d" % len(s))

    def generate_no_test(self, maxn, third=False):
        length = maxn
        if random.randint(1, 2) == 1:
            length -= 1
        if (third == True) and (length % 2 == 1):
            length += 1
        s = ""
        for i in range(length // 2):
            s += chr(random.randint(0, 25) + ord('a'))
        if length % 2 == 1:
            s = s + chr(random.randint(0, 25) + ord('a')) + s[::-1]
        else:
            s = s + s[::-1]
        l = random.randint(0, len(s) - 1)
        r = random.randint(l, len(s) - 1)
        while l == r or s[l] == s[r]:
            l = random.randint(0, len(s) - 1)
            r = random.randint(l, len(s) - 1)        
        s = self.swap_in_string(s, l, r)
        l = random.randint(0, len(s) - 1)
        r = random.randint(l, len(s) - 1)
        while l == r or s[l] == s[r]:
            l = random.randint(0, len(s) - 1)
            r = random.randint(l, len(s) - 1)        
        self.print_test(self.swap_in_string(s, l, r), "Random no test, |s| = %d" % len(s))

    def generate_tricky_test(self, maxn):
        c1 = chr(ord('a') + random.randint(0, 25))
        c2 = chr(ord('a') + random.randint(0, 25))
        c3 = chr(ord('a') + random.randint(0, 25))
        while (c3 == c1) or (c3 == c2):
            c3 = chr(ord('a') + random.randint(0, 25))
        s = ""
        for i in range(maxn // 2):
            if random.randint(1, 2) == 1:
                s += c1
            else:
                s += c2
        s += s[::-1]
        l1 = random.randint(0, maxn // 2 - 1)
        r1 = maxn - l1 - 1
        l2 = random.randint(0, maxn // 2 - 1)
        while l1 == l2:
            l2 = random.randint(0, maxn // 2 - 1)
        r2 = maxn - l2 - 1
        self.print_test(self.swap_in_string(s, l1, l2), "Big yes test, |s| = %d" % len(s))
        self.print_test(self.swap_in_string(s, l1, r1), "Big yes test, |s| = %d" % len(s))
        self.print_test(self.swap_in_string(s, l1, r2), "Big yes test, |s| = %d" % len(s))
        self.print_test(self.swap_in_string(s, l2, r1), "Big yes test, |s| = %d" % len(s))
        self.print_test(self.swap_in_string(s, l2, r2), "Big yes test, |s| = %d" % len(s))
        self.print_test(self.swap_in_string(s, r1, r2), "Big yes test, |s| = %d" % len(s))
        s = self.swap_in_string(s, l2, r1)
        s = s[:r1] + c3 + s[r1 + 1:]
        self.print_test(s, "Big no test, |s| = %d" % len(s))

    def generate_first_group_of_tests(self, folder):
        self.subtask = folder
        maxn = 100
        self.print_test("a", "s = a")
        self.print_test("z", "s = z")
        self.print_test("aa", "s = aa")
        self.print_test("ab", "s = ab")
        self.print_test("aab", "s = aab")
        self.print_test("baa", "s = baa")
        self.print_test("abab", "s = abab")
        self.print_test("aabb", "s = aabb")
        self.print_test("abbac", "s = abbac")
        self.print_test("acdbbeca", "s = acdbbeca")
        for i in range(3):
            self.generate_yes_test(maxn)
        for i in range(3):
            self.generate_no_test(maxn)

    def generate_second_group_of_tests(self, folder):
        self.subtask = folder
        maxn = 1000
        self.print_test("aab", "s = aab")
        self.print_test("baa", "s = baa")
        self.print_test("abab", "s = abab")
        self.print_test("aabb", "s = aabb")
        self.print_test("abbac", "s = abbac")
        self.print_test("acdbbeca", "s = acdbbeca")
        for i in range(3):
            self.generate_yes_test(maxn)
        for i in range(3):
            self.generate_no_test(maxn)
        
    def generate_third_group_of_tests(self, folder):
        self.subtask = folder
        self.print_test("acdbbeca", "s = acdbbeca")
        maxn = 10**5
        for i in range(3):
            self.generate_yes_test(maxn, True)
        for i in range(3):
            self.generate_no_test(maxn, True)
        s = "a" * (maxn // 2 - 2) + "ba" + "a" * (maxn // 2 - 2)
        self.print_test(s, "Big no test, |s| = %d" % len(s))
        s = "ab" * (maxn // 4) + "ab" * (maxn // 4)
        ind = random.randint(0, len(s) - 1)
        self.print_test(s[:ind] + chr(random.randint(0, 25) + ord('a')) + s[ind + 1:], "Big no test, |s| = %d" % len(s))
        self.generate_tricky_test(maxn)            

    def generate_fourth_group_of_tests(self, folder):
        self.subtask = folder
        self.print_test("acdbbeca", "s = acdbbeca")
        self.print_test("acab", "s = acdbbeca")
        maxn = 10**5
        for i in range(3):
            self.generate_yes_test(maxn)
        for i in range(3):
            self.generate_no_test(maxn)
        s = "a" * (maxn // 2 - 2) + "baa" + "a" * (maxn // 2 - 2)
        self.print_test(s, "Big yes test, |s| = %d" % len(s))
        s = "a" * (maxn // 2) + "b" * (maxn // 2)
        ind = random.randint(0, len(s) - 1)
        self.print_test(s[:ind] + chr(random.randint(0, 25) + ord('a')) + s[ind + 1:], "Big no test, |s| = %d" % len(s))
        self.generate_tricky_test(maxn)            
               
    def print_test(self, s, description, points=0, folder="tests"):
        self.test_number += 1
        print("Generating test %d" % self.test_number)
        
        dirname = os.path.join('..', folder)
        test_name = os.path.join(dirname, "{0:0=2d}".format(self.test_number))
        if not os.path.exists(dirname):
            os.makedirs(dirname)
        test_file = open(test_name, "w")
        print(s, file=test_file)
        print(test_name + ", folder=" + folder + ", subtask=" + self.subtask + ", points=" + str(points) + ", comment=\"" + description + "\"", file=self.desc_file)
        test_file.close()

    def generate_all_tests(self):
        self.generate_samples() 
        self.test_number = 0
        
        #First group of tests
        self.generate_first_group_of_tests("subtask1")
        print("comment_subtask1=\"|s| &lt;= 100\"", file=self.desc_file)
        print("bonus_subtask1=16", file=self.desc_file)
        
        #Second group of tests
        self.generate_second_group_of_tests("subtask2")
        print("comment_subtask2=\"|s| &lt;= 2000\"", file=self.desc_file)
        print("bonus_subtask2=27", file=self.desc_file)

        #Third group of tests
        self.generate_third_group_of_tests("subtask3")
        print("comment_subtask3=\"|s| &lt;= 10^5, |s| % 2 == 0\"", file=self.desc_file)
        print("bonus_subtask3=35", file=self.desc_file)

        #Fourth group of tests
        self.generate_fourth_group_of_tests("subtask4")
        print("comment_subtask4=\"|s| &lt;= 10^5\"", file=self.desc_file)
        print("bonus_subtask4=22", file=self.desc_file)
        
        self.desc_file.close()

import os, shutil
if os.path.exists('../tests'):
    shutil.rmtree('../tests', ignore_errors=False, onerror=None)
if os.path.exists('../preliminary'):
    shutil.rmtree('../preliminary', ignore_errors=False, onerror=None)
try:
    os.makedirs('../tests')
    os.makedirs('../preliminary')
except OSError:
    pass

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)
